/*****************************************************************************/
/* Substance.h - A library for object list.                                  */
/*                                                                           */
/* Substance.h Copyright (c) 2000 Sakai Hiroaki.                             */
/* All Rights Reserved.                                                      */
/*****************************************************************************/

/*****************************************************************************/
/* Substance 2000/1    Sakai Hiroaki                                         */
/*===========================================================================*/
/* Υ饤֥ϡSubstance ֥Ȥ뤿ΤΤǤ      */
/* Substance.h 򥤥󥯥롼ɤƻȤäƤ                            */
/* SubstanceP.h ϡ饤֥ѤΥץ饤١ȥإåʤΤǡ̤ˤ   */
/* 󥯥롼ɤʤȡ                                                  */
/*****************************************************************************/

#ifndef _SAKAILIB_SUBSTANCE_H_INCLUDED_
#define _SAKAILIB_SUBSTANCE_H_INCLUDED_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _SubstanceClass {
  char * class_name;
  int number;
} _SubstanceClass;

typedef void * Substance;
typedef struct _SubstanceClass * SubstanceClass;
typedef struct _SubstanceClass SubstanceClassPart;
typedef struct _SubstanceCore * SubstanceCore;
typedef struct _SubstanceList * SubstanceList;

typedef Substance (*SubstanceDestructor)();

/*****************************************************************************/
/* 饹                                                              */
/*****************************************************************************/

char * ClassGetName(SubstanceClass substance_class);
int SubstanceIsClass(Substance substance, SubstanceClass substance_class);

/*****************************************************************************/
/* Substance                                                            */
/*****************************************************************************/

char * SubstanceGetClassName(Substance substance);
int SubstanceCheckClass(Substance substance, char * substance_class);
int SubstanceGetNumber(Substance substance);
int SubstanceSetNumber(Substance substance, int number);
int SubstanceGetSerial(Substance substance);
int SubstanceSetSerial(Substance substance, int serial);
Substance SubstanceGetParent(Substance substance);
SubstanceList SubstanceGetChildren(Substance substance);

/*****************************************************************************/
/* SubstanceCore                                                        */
/*****************************************************************************/

SubstanceCore SubstanceCoreCreate(SubstanceClass substance_class, Substance parent);
SubstanceCore SubstanceCoreDestroy(SubstanceCore core);

/*****************************************************************************/
/* SubstanceList ֥Ȥ                                           */
/*****************************************************************************/

Substance SubstanceListGetSubstance(SubstanceList list);
int SubstanceListGetLength(SubstanceList list);
int SubstanceListIsEmpty(SubstanceList list);
int SubstanceListIsCurrentStartEdge(SubstanceList list);
int SubstanceListIsCurrentEndEdge(SubstanceList list);
int SubstanceListIsCurrentStart(SubstanceList list);
int SubstanceListIsCurrentEnd(SubstanceList list);
int SubstanceListSetCurrentToStartEdge(SubstanceList list);
int SubstanceListSetCurrentToEndEdge(SubstanceList list);
int SubstanceListSetCurrentToStart(SubstanceList list);
int SubstanceListSetCurrentToEnd(SubstanceList list);
int SubstanceListMoveCurrentToPrev(SubstanceList list);
int SubstanceListMoveCurrentToNext(SubstanceList list);
int SubstanceListInsertSubstanceToPrev(SubstanceList list, Substance substance,
				 Substance (*destructor)());
int SubstanceListInsertSubstanceToNext(SubstanceList list, Substance substance,
				 Substance (*destructor)());
int SubstanceListInsertSubstanceToStart(SubstanceList list, Substance substance,
				  Substance (*destructor)());
int SubstanceListInsertSubstanceToEnd(SubstanceList list, Substance substance,
				Substance (*destructor)());
int SubstanceListDeleteSubstanceToPrev(SubstanceList list);
int SubstanceListDeleteSubstanceToNext(SubstanceList list);
int SubstanceListDeleteSubstanceFromStart(SubstanceList list);
int SubstanceListDeleteSubstanceFromEnd(SubstanceList list);
SubstanceList SubstanceListCreate(); /* SubstanceList ֥Ȥ */
SubstanceList SubstanceListDestroy(SubstanceList list); /*  */
Substance SubstanceListSearchSubstance(SubstanceList list, int serial);

#endif

